/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.diennea.testproject;


import java.io.DataOutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicInteger;
import org.junit.Test;

/**
 *
 * @author marco.malavolta
 */
public class StressTest  {
    
    private static final String SITE_DOMAIN = "http://localhost:11789/";

    @Test
    //@Ignore
    public void stressTest() throws Exception {


        long _start = System.currentTimeMillis();
        int threads = 50;
        int ntasks = 10000;
        final AtomicInteger countdone = new AtomicInteger();
        ExecutorService threadpool = Executors.newFixedThreadPool(threads);
        for (int i = 0; i < ntasks; i++) {
            threadpool.submit(new Runnable() {

                public void run() {
                    try {
                        performLogin(countdone);
                    } catch (Throwable ex) {
                        ex.printStackTrace();
                    }
                }
            });
        }
        threadpool.shutdown();
      
        while (true) {
            System.out.println("Waiting for termination...done " + countdone.get() + " tasks");
            boolean finished = threadpool.awaitTermination(1, TimeUnit.SECONDS);
            if (finished) {
                break;
            }
        }


        long _stop = System.currentTimeMillis();
        System.out.println("total time: " + (_stop - _start) + " ms");
    }

    private void performLogin(AtomicInteger counter) throws Exception {
        String targetUrl = SITE_DOMAIN + "login";
        
        String urlParameters = "";

        executeHttpCall(targetUrl, urlParameters, "GET");
     
        counter.incrementAndGet();
    }

    private void performSubmitLogin(AtomicInteger counter) throws Exception {
        String targetUrl = SITE_DOMAIN + "login";
        
        String urlParameters =
                "userName=" + URLEncoder.encode("administrator", "UTF-8")
                + "&password=" + URLEncoder.encode("Passwordsfdds", "UTF-8");

        executeHttpCall(targetUrl, urlParameters, "POST");
     
        counter.incrementAndGet();
    }

    private void executeHttpCall(String targetUrl, String urlParameters, String method) throws Exception {
        
        
        URL url;
        HttpURLConnection connection = null;
        DataOutputStream wr = null;
        try {
            //Create connection
            url = new URL(targetUrl);
            connection = (HttpURLConnection) url.openConnection();
            connection.setRequestMethod(method);
            connection.setRequestProperty("Content-Type",
                    "application/x-www-form-urlencoded");

            connection.setRequestProperty("Content-Length", ""
                    + Integer.toString(urlParameters.getBytes().length));
            connection.setRequestProperty("Content-Language", "en-US");

            connection.setUseCaches(false);
            connection.setDoInput(true);
            connection.setDoOutput(true);

            //Send request


            wr = new DataOutputStream(connection.getOutputStream());
            wr.writeBytes(urlParameters);
            wr.flush();
            

            //Get Response	code
            long start = System.currentTimeMillis();
            int responseCode = connection.getResponseCode();
            if (responseCode != 200) {
                System.out.println("Response code: " + responseCode);
            }
        } finally {
            if (wr != null) {
                wr.close();
            }
            if (connection != null) {
                connection.disconnect();
            }
        }

    }

    
}